<xs:schema targetNamespace="http://data.naturalis.nl/nba-dataset-config"
  elementFormDefault="qualified" attributeFormDefault="unqualified" xmlns:xs="http://www.w3.org/2001/XMLSchema"
  xmlns:self="http://data.naturalis.nl/nba-dataset-config" version="1.0"
>

  <!-- This XSD is used to generate the JAXB classes in nl.naturalis.dao.format.config -->

  <!-- IMPORTANT: After xjc has generated a class for DataSetXmlConfig-->
  <!-- [1] Annotate the class with: @XmlRootElement(name = "dataset-config") -->
  <!-- [2] Set name attribute of @XmlType annotation to empty string ("")-->
  <!-- Otherwise you _WILL_ get errors when parsing config files using JAXB -->

  <xs:complexType name="DataSetXmlConfig">
    <xs:sequence>
      <xs:element name="shared-data-source" type="self:DataSourceXmlConfig" minOccurs="0"/>
      <xs:element name="entity" type="self:EntityXmlConfig" maxOccurs="unbounded"/>
    </xs:sequence>
  </xs:complexType>

  <xs:complexType name="EntityXmlConfig">
    <xs:sequence>
      <xs:element name="data-source" type="self:DataSourceXmlConfig" minOccurs="0"/>
      <xs:element name="path" type="xs:string" minOccurs="0"/>
      <xs:element name="filter" type="self:PluginXmlConfig" minOccurs="0" maxOccurs="unbounded"/>
      <xs:element name="mapping" type="self:MappingXmlConfig"/>
    </xs:sequence>
    <xs:attribute name="name" type="xs:string" use="required"/>
  </xs:complexType>

  <xs:complexType name="DataSourceXmlConfig">
    <xs:sequence>
      <xs:choice minOccurs="0">
        <xs:element name="java-class" type="xs:string"/>
      </xs:choice>
      <xs:element name="document" type="xs:string" minOccurs="0" maxOccurs="1"/>
      <xs:element name="query-spec" type="self:QuerySpecXmlConfig" minOccurs="0"/>
    </xs:sequence>
  </xs:complexType>

  <xs:complexType name="MappingXmlConfig">
    <xs:sequence>
      <xs:element name="field" type="self:FieldXmlConfig" maxOccurs="unbounded"/>
    </xs:sequence>
  </xs:complexType>

  <xs:complexType name="FieldXmlConfig">
    <xs:sequence>
      <xs:choice>
        <xs:element name="path" type="self:PathXmlConfig"/>
        <xs:element name="constant" type="xs:string"/>
        <xs:element name="calculator" type="self:PluginXmlConfig"/>
      </xs:choice>
    </xs:sequence>
    <xs:attribute name="name" type="xs:string" use="required"/>
    <xs:attribute name="term" type="xs:anyURI"/>
    <xs:attribute name="isCoreId" type="xs:boolean"/>
  </xs:complexType>

  <xs:complexType name="PathXmlConfig">
    <xs:simpleContent>
      <xs:extension base="xs:string">
        <xs:attribute name="relative" type="xs:boolean"/>
      </xs:extension>
    </xs:simpleContent>
  </xs:complexType>

  <xs:complexType name="PluginXmlConfig">
    <xs:sequence>
      <xs:element name="java-class" type="xs:string"/>
      <xs:element name="arg" type="self:PluginParamXmlConfig" minOccurs="0"
        maxOccurs="unbounded"/>
    </xs:sequence>
  </xs:complexType>

  <xs:complexType name="PluginParamXmlConfig">
    <xs:simpleContent>
      <xs:extension base="xs:string">
        <xs:attribute name="name" type="xs:string" use="required"/>
      </xs:extension>
    </xs:simpleContent>
  </xs:complexType>

  <xs:complexType name="QuerySpecXmlConfig">
    <xs:sequence>
      <xs:element name="conditions" type="self:ConditionsXmlConfig"/>
      <xs:element name="sort-fields" type="self:SortFieldXmlConfig" minOccurs="0"
        maxOccurs="unbounded"/>
      <!-- from and size are actually integers, but we don't want things to go wrong already during
        JAXB deserialization, because that would produce rather hard-to-trace number format exceptions. -->
      <xs:element name="from" type="xs:string" minOccurs="0"/>
      <xs:element name="size" type="xs:string" minOccurs="0"/>
    </xs:sequence>
  </xs:complexType>

  <xs:complexType name="SortFieldXmlConfig">
    <xs:simpleContent>
      <xs:extension base="xs:string">
        <xs:attribute name="ascending" type="xs:boolean"/>
      </xs:extension>
    </xs:simpleContent>
  </xs:complexType>

  <xs:complexType name="ConditionsXmlConfig">
    <xs:sequence>
      <xs:element name="condition" type="self:ConditionXmlConfig" maxOccurs="unbounded"/>
    </xs:sequence>
    <xs:attribute name="operator" type="self:LogicalOperatorXmlConfig"/>
  </xs:complexType>

  <xs:simpleType name="LogicalOperatorXmlConfig" final="restriction">
    <xs:restriction base="xs:string">
      <xs:enumeration value="AND"/>
      <xs:enumeration value="OR"/>
    </xs:restriction>
  </xs:simpleType>

  <xs:complexType name="ConditionXmlConfig">
    <xs:sequence>
      <xs:element name="field" type="xs:string"/>
      <xs:element name="operator" type="xs:string"/>
      <xs:element name="value" type="xs:string"/>
      <xs:element name="and" type="self:ConditionXmlConfig" minOccurs="0"
        maxOccurs="unbounded"/>
      <xs:element name="or" type="self:ConditionXmlConfig" minOccurs="0"
        maxOccurs="unbounded"/>
    </xs:sequence>
    <xs:attribute name="negated" type="xs:boolean"/>
  </xs:complexType>

</xs:schema>
